'use strict';

var framework = require('@sapphire/framework');
var pieces = require('@sapphire/pieces');
require('../Subcommand.cjs');
var Enums_cjs = require('../types/Enums.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function parseSubcommandConstructorPreConditionsCooldown({
  subcommand: command,
  cooldownLimit,
  cooldownDelay,
  cooldownScope,
  cooldownFilteredUsers,
  subcommandMethodName,
  subcommandGroupName,
  preconditionContainerArray
}) {
  const { subcommandDefaultCooldown } = pieces.container.client.options;
  const filtered = subcommandDefaultCooldown?.filteredCommands?.includes(
    subcommandGroupName ? `${command.name}.${subcommandGroupName}.${subcommandMethodName}` : `${command.name}.${subcommandMethodName}`
  ) ?? false;
  const limit = cooldownLimit ?? (filtered ? 0 : subcommandDefaultCooldown?.limit ?? 1);
  const delay = cooldownDelay ?? (filtered ? 0 : subcommandDefaultCooldown?.delay ?? 0);
  if (limit && delay) {
    const scope = cooldownScope ?? subcommandDefaultCooldown?.scope ?? framework.BucketScope.User;
    const filteredUsers = cooldownFilteredUsers ?? subcommandDefaultCooldown?.filteredUsers;
    preconditionContainerArray.append({
      name: Enums_cjs.SubcommandCommandPreConditions.PluginSubcommandCooldown,
      context: { scope, limit, delay, filteredUsers, subcommandGroupName, subcommandMethodName }
    });
  }
}
__name(parseSubcommandConstructorPreConditionsCooldown, "parseSubcommandConstructorPreConditionsCooldown");

exports.parseSubcommandConstructorPreConditionsCooldown = parseSubcommandConstructorPreConditionsCooldown;
//# sourceMappingURL=subcommandCooldown.cjs.map
//# sourceMappingURL=subcommandCooldown.cjs.map